#include <sort.h>

TYPE getPivot(TYPE * const array, int left, int right);
int quicksort(TYPE * const array, int left, int right);

int sort(TYPE * const array, int left, int right) {
  return quicksort(array, left, right);
}

int quicksort(TYPE * const array, int left, int right) {
  int i = left;
  int j = right;
  TYPE tmp;
  TYPE pivot = getPivot(array, left, right);

  while (i <= j) {
    while (array[i] < pivot) i++;
    while (array[j] > pivot) j--;
    if (i <= j) {
      tmp = array[i];
      array[i] = array[j];
      array[j] = tmp;
      i++;
      j--;
    }
  }

  if (left < j)
    quicksort(array, left, j);
  if (right > i)
    quicksort(array, i, right);
  return 0;
}

TYPE getPivot(TYPE * const array, int left, int right) {
  return array[(left + right) / 2];
}
